'From Squeak3.2alpha of 1 November 2001 [latest update: #4599] on 29 January 2002 at 10:48:11 am'!

!BufferStream methodsFor: 'accessing' stamp: 'gh 1/4/2002 12:57'!
peek
	"return the next character without consuming it"
	"consume it"
	^buffer at: startPos! !


!ComancheService class methodsFor: 'registration' stamp: 'gh 1/7/2002 12:57'!
serviceNamed: aString
	^self services at: aString ifAbsent: [nil]! !


!SocketStream methodsFor: 'stream in' stamp: 'gh 1/7/2002 08:41'!
nextLine
	"Get the next line from the server.
	We use lf as line separator. A single preceding cr
	will be discarded in order to be compatible with
	clients sending crlfs instead of only lf."
	
	| nextLine |
	nextLine _ self upTo: Character lf.
	self next. "eat the lf"
	(nextLine size > 0 and: [nextLine last = Character cr])
		 ifTrue:[^nextLine allButLast].
	^nextLine! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/7/2002 13:20'!
nextLineCr
	"Get the next line from the server.
	We use cr as line separator. A single following lf
	will be discarded in order to be compatible with
	clients sending crlfs instead of only cr."
	
	| nextLine |
	nextLine _ self upTo: Character cr.
	self next. "eat the cr"
	(self peek = Character lf)
		 ifTrue:[self next].
	^nextLine! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/4/2002 12:57'!
peek
	self atEnd ifTrue: [^nil].
	inStream isEmpty ifTrue: [self pvtGetData].
	^inStream peek! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/10/2002 11:28'!
upToAll: delims

	[(inStream includesAll: delims)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upToAll: delims].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			^inStream upToEnd].
	"Did not find it, we fetch some more and try again..."
	self pvtGetData] repeat! !

!SocketStream methodsFor: 'stream out' stamp: 'gh 1/4/2002 14:08'!
cr
	self nextPut: Character cr! !

!SocketStream methodsFor: 'stream out' stamp: 'gh 1/4/2002 14:08'!
lf
	self nextPut: Character lf! !

